   podtf(l,m,y)

      /* computes the probability that less than m events occur in */
      /* unit time in a series of events which have a poisson      */
      /* distribution over time.                                   */

      int l,m;
      float *y;

    {
      int i;
      float xl,z;
      extern double pow();

      *y = 0.0;
      if (m <= 0) return;
      xl = l;
      z = pow(.36789,xl);

      for(i = 1; i <= m; i++)
      {
       *y = *y + z;
       z = z * xl / i;
      }
    }
