   stanv1 (n,m,k,x,f,av)

      /* this function uses the data of a one-way, completely randomized */
      /* experiment to compute the analysis of variance table and the    */
      /* f - ratio to test the significance of the difference between    */
      /* treatment means.                                                */

      int k[],m,n;
      float av[],x[],*f;

   {
      int i,j,j1,kk;
      float t,u,v,xk;

      av[0] = 0.;
      u = 0.;
      v = 0.;
      kk = 0;

      for(i = 0; i <= m-1; i++)
      {
       t = 0.;
       j1 = kk + 1;
       kk = kk + k[i];
       xk = k[i];

       for(j = j1-1; j <= kk-1; j++)
       {
        av[0] = av[0] + x[j] * x[j];
        t = t + x[j];
       }
       u = u + t;
       v = v + t * t / xk;
      }

      av[1] = n - 1;
      av[2] = u * u/av[1];
      av[3] = 1.;
      av[4] = v - av[2];
      av[5] = m - 1;
      av[6] = av[4]/av[5];
      av[7] = av[0] - v;
      av[8] = n - m;
      av[9] = av[7]/av[8];
      *f = av[6]/av[9];
   }
