   admbas(n,h,f,b)

      /*purpose...integral of given function by Adams-Bashforth.*/

     int n;
     float h,f[],*b;

    {

     int i,n3;
     float sum;

      sum = 0.;

      if(n == 6) goto ne6;
      if(n < 6) goto nl6;

       n3 = n - 4;
       for(i = 3; i <= n3 ; i++)
        sum += f[i];
       sum *= 24.;

ne6:  sum -= 31. * f[2] + 33. * f[n-3];
      goto nne6;
nl6:  if(n < 5) goto nl5;
      sum -= 22. * f[2];
nne6: sum += 28. * f[1] - 4. * f[n-2];
      goto nge5;
nl5:  sum = sum + 37. * f[1] - 59. * f[2];
nge5: sum = sum - 9. * f[0] + 55. * f[n-1];
      *b = (sum*h)/24.;
    }

