  defoma(iter,h,x,y,dy,iflag,d)

      /* subroutine to solve first-order ordinary differential */
      /* equations y' = f(x,y) by modified Adam's method.      */

      int iflag,iter;
      float d[],dy[],h,x[],y[];

   {
      int i,j;
      float xn,yn,yi;
      double yprime();

      d[0] = 0.;
      d[1] = 0.;
      d[2] = 0.;
      xn = x[0];
      yn = y[0];
      dy[0] = yprime(xn,yn,iflag);
      j = 4;
      defork(j,h,x,y,dy,iflag);

      for(i = 3; i <= iter-2; i++)
      {
      xn = x[i+1];
      yn = y[i] + h*(55.*dy[i] - 59.*dy[i-1]+37.*dy[i-2]-9.*dy[i-3])/24.;
      yi = yn;
      dy[i+1] = yprime(xn,yn,iflag);
      y[i+1] = y[i]+h*(9.*dy[i+1]+19.*dy[i]-5.*dy[i-1]+dy[i-2])/24.;
      xn = x[i+1];
      yn = y[i+1];
      dy[i+1] = yprime(xn,yn,iflag);
      d[i+1] = -19.*(y[i+1] - yi)/270.;
      }
    }
