   integs(m,y,xlow,xhi,ans)

      /*this function evaluates the definite integral of a */
      /*function by Simpson's one-third rule.              */

      int m;
      float y[],xlow,xhi,*ans;

    {
      int xm,mm4,i;

      xm = m;
      mm4 = m - 4;
      *ans = 0.0;
      if (m <= 1) return;
      *ans = y[0] + 4.0*y[m - 2] + y[m-1];
      if(m != 3)
      {
       for(i = 1; i <= mm4; i += 2)
        *ans = *ans + 4.0*y[i] + y[i + 1] + y[i + 1];
      }
      *ans = *ans * (xhi - xlow)/(3.0*(xm - 1.0));
    }
