   nacply(n,a,b,c)

      /*function to generate a chebyshev polynomial    */
      /* of degree N.                                  */

      int n;
      float a[],b[],c[];

   {
      int i,ij,ijk;

      if(n <= 1)
      {
      a[0] = 1.;
      return;
      }
      for(i = 0; i <= n; i++)
      {
       a[i] = 0.;
       b[i] = 0.;
       c[i] = 0.;
      }
      b[0] = 1.;
      c[0] = 1.;

      for(ijk = 2; ijk <= n; ijk++)
      {
       ij = ijk + 1;
       a[0] = 2. * b[0];
       a[1] = 2. * b[1];

       for(i = 2; i <= ij-1; i++)
       {
        a[i] = (2. * b[i]) - c[i-2];
       }
       for(i = 0; i <= ij-1; i++)
       {
        c[i] = b[i];
        b[i] = a[i];
       }
      }
    }
