      stcorr (n,x,y,r)

      /*this subroutine computes a correlation coefficient for n*/
      /*pairs of values.*/

      int n;
      float x[],y[],*r;

     {

      extern double sqrt();
      float sumx,sumy,sumxy,sumx2,sumy2,en,t;
      int i;

      sumx = sumy = sumxy = sumx2 = sumy2 = 0.0;

      for (i = 0; i <= n-1; i++)
      {
        sumx = sumx + x[i];
        sumy = sumy + y[i];
        sumxy = sumxy + x[i]*y[i];
        sumx2 = sumx2 + x[i]*x[i];
        sumy2 = sumy2 + y[i]*y[i];
      }

      en = n;
      t = (en*sumx2-sumx*sumx)*(en*sumy2-sumy*sumy);
      *r = (en*sumxy-sumx*sumy)/sqrt(t);

     }
