      stngbi (i,kk,p,df,cf)

      /*this subroutine computes the probability and cumulative*/
      /*distribution of negative binomial distribution of the form*/
      /*df(kk,i,p)=c(i+kk-1.,kk)*p**i*(1.-p)**kk for arbitrary fixed*/
      /*integer i greater than zero and p in the interval 0 to 1.*/

      int i,kk;
      float p,*df,*cf;

     {

      int j,k,l;
      float ri,skk,s1,fj,t,s2,fl;
      extern double pow();

      ri = i;
      *cf = pow(p,ri);
      *df = *cf;

      if (kk <= 0) return;

      for (k = 1; k <= kk; k++)
      {
        skk = k;
        s1 = 1.;

        for (j = 1; j <= k; j++)
        {
          fj = j;
          t = ri + skk - fj;
          s1 = s1*t;
        }
        s2 = 1.;

        for (l = 1; l <= k; l++)
        {
          fl = l;
          s2 = s2*fl;
        }
        *df = (s1/s2)*pow(p,ri)*pow((1.-p),skk);
        *cf = *cf + *df;
      }

     }
